## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 5;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm 1.9.0
%bcond_without check

# https://github.com/yggdrasil-network/yggdrasil-go
%global goipath         github.com/yggdrasil-network/yggdrasil-go
Version:                0.5.9

# add -f for Fedora
%if 0%{?fedora} > 36
%gometa -f
%else
%gometa 
%endif

%global common_description %{expand:
An experiment in scalable routing as an encrypted IPv6 overlay network.}

%global golicenses      LICENSE contrib/yggdrasil-brute-simple/LICENSE
%global godocs          CHANGELOG.md README.md contrib/yggdrasil-brute-\\\
                        simple/README.md

Name:           yggdrasil-network
Release:        %autorelease
Summary:        An experiment in scalable routing as an encrypted IPv6 overlay network

License:        CC0-1.0
URL:            %{gourl}
Source:         %{gosource}
Source1:        https://github.com/yggdrasil-network/yggdrasil-go/releases/download/v%{version}/yggdrasil-%{version}-vendored.tar.gz
Source2:	yggdrasil.xml
Patch:		yggdrasil.service.patch

# systemd macros are not defined unless systemd is present
BuildRequires: systemd systemd-rpm-macros
BuildRequires: firewalld-filesystem
#BuildRequires: golang-github-hjson-devel

Requires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Requires: firewalld-filesystem

%description %{common_description}

%gopkg

%prep
%goprep
#setup -qn yggdrasil-go-%{version}
tar xfz %{SOURCE1} ./vendor
%patch 0 -p1 -b .sysd

%generate_buildrequires
# Use vendored dependencies.  What about licenses?
#go_generate_buildrequires


%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done
for cmd in contrib/ansible; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

mkdir -p %{buildroot}%{_unitdir}
install -pm 644 contrib/systemd/yggdrasil.service %{buildroot}%{_unitdir}/yggdrasil-network.service
install -pm 644 contrib/systemd/yggdrasil-default-config.service %{buildroot}%{_unitdir}/

mkdir -p %{buildroot}%{_libexecdir}/%{name}
# conflicts with ansible-core
mv %{buildroot}%{_bindir}/ansible %{buildroot}%{_libexecdir}/%{name}
mv %{buildroot}%{_bindir}/genkeys %{buildroot}%{_libexecdir}/%{name}

mkdir -p %{buildroot}%{_prefix}/lib/firewalld/services/
install -pm 644 %{SOURCE2} %{buildroot}%{_prefix}/lib/firewalld/services/

%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE 
#license contrib/yggdrasil-brute-simple/LICENSE
%doc CHANGELOG.md README.md 
#doc contrib/yggdrasil-brute-simple/README.md
%{_libexecdir}/%{name}
%{_prefix}/lib/firewalld/services/
%{_bindir}/*
%{_unitdir}/*

%gopkgfiles

%post
%systemd_post yggdrasil-network.service
%systemd_post yggdrasil-default-config.service
%firewalld_reload

%postun
%systemd_postun_with_restart yggdrasil-network.service
%systemd_postun_with_restart yggdrasil-default-config.service

%preun
%systemd_preun yggdrasil-network.service
%systemd_preun yggdrasil-default-config.service

%changelog
* Sun Aug 20 2023 Stuart D. Gathman <stuart@gathman.org> - 0.4.7-5
- More sandboxing, use %%firewalld_reload

* Sat Aug 19 2023 Stuart D. Gathman <stuart@gathman.org> - 0.4.7-4
- Missing LICENSE and use DynamicUser for service

* Thu Aug 17 2023 Stuart D. Gathman <stuart@gathman.org> - 0.4.7-3
- Add static listening port and yggdrasil firewalld service

* Thu Aug 17 2023 Stuart D. Gathman <stuart@gathman.org> - 0.4.7-2
- Rename to avoid conflicts with existing unrelated package named
  yggdrasil.

* Thu Aug 17 2023 Stuart D. Gathman <stuart@gathman.org> - 0.4.7-1
- Rename stuff to coordinate with yggd project named yggdrasil
